package it.istat.relais.displayTables;

import javax.swing.table.AbstractTableModel;

public class SubRulesModel extends AbstractTableModel{

int dimension;
private String[] subrules;


public SubRulesModel(String[] subrules) {

    super(); 

    this.dimension=subrules.length;
    this.subrules = new String[dimension];

    
    for (int index=0;index<dimension;index++) {
        this.subrules[index]=subrules[index];
    }
    
}

public int getRowCount(){
    return dimension;
} 


public int getColumnCount(){
   return 1;  
}


public Object getValueAt(int rowIndex, int columnIndex) {

return subrules[rowIndex];
}


        @Override
public String getColumnName(int columnIndex) { 
            
return "Sub-Rule";
}
        
        @Override
public boolean isCellEditable(int row, int column) {
        return false;
}
        
        @Override
    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }

}
