package it.istat.relais.output;

import java.io.IOException;
import it.istat.relais.datasetInput.Record;

public class RecordWriter extends RowWriter {
	
	private String separator;
	
	public RecordWriter(String pathname, String separator, boolean append)
	throws IOException {
		super(pathname, append);
		this.separator = separator;
	}
	
	public RecordWriter(String pathname, String separator, boolean append, int buffer_sz)
	throws IOException {
		super(pathname, append, buffer_sz);
		this.separator = separator;
	}
	
	public void writeRecord(Record record) {
		String row;
		
		row = record.toString(separator);
		write(row);	
	}
	
}
