package it.istat.relais.searchSpaceCreation;

import it.istat.relais.constants.TablesName;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;


public class CrossProduct {
Connection connection;
private String method;
	
	public CrossProduct(Connection con){
		this.connection = con;
		this.method = "CrossProduct";
	}

        /* creation of the search space table by cross product */
	public String CreateCrossProduct() throws Exception {
		Statement stmDrop, stmCreate, stmInsert = null;
		String insertString;
		String tableNameCP = TablesName.nameSearchSpaceTemp();
		
		try{
                    try{
                        stmDrop = (Statement)connection.createStatement();
                        stmDrop.executeUpdate("DROP TABLE " +tableNameCP+ ";");
                    }catch(SQLException e){
                    }

                    stmCreate =(Statement)connection.createStatement();
                    stmCreate.executeUpdate("CREATE TABLE "+tableNameCP+" (KEY_DSA INTEGER UNSIGNED NOT NULL, KEY_DSB INTEGER UNSIGNED NOT NULL, PATTERN VARCHAR(150), ROWNUMBER BIGINT UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ROWNUMBER)) ENGINE = MYISAM;");

                    insertString = "INSERT INTO "+tableNameCP+" (KEY_DSA, KEY_DSB) ";
                    insertString = insertString+"SELECT A.KEY_DSA, B.KEY_DSB FROM "+TablesName.nameDsa()+" A, "+TablesName.nameDsb()+" B";
		
                     /* dedup option */
                    VariablesSetting vsdedup = new VariablesSetting(connection);
                    if (vsdedup.ReadProjectType().equalsIgnoreCase("Deduplication")) {
                        insertString = insertString + " WHERE A.KEY_DSA > B.KEY_DSB";
                    }

                    stmInsert=(Statement)connection.createStatement();
                    stmInsert.executeUpdate(insertString);
                    stmInsert.close();
           
		}catch (Exception e) {
			e.printStackTrace();		
                        throw e;
	}
	return this.method;
 }
}	
