/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.istat.relais.datasetInput;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import it.istat.relais.log.TraceLog;

public class ReadingDBMySQL {
    private Connection connection;
    private TraceLog log;
    public ReadingDBMySQL(Connection conn){
        this.connection = conn;
        this.log = new TraceLog(conn);
    }

    public void ReadingDB (String host, String port, String dataBase, String userName, String passWord, String tableDSA, String tableDSB)throws Exception{
           ArrayList<String> column, column1;
           String createDSA, createDSB;
           Connection conn=null;
           String DBMYSQL ="";
           log.AddMessage("Start connection DB MySQL",false);     
           if (host.equalsIgnoreCase("localhost")){
               DBMYSQL ="jdbc:mysql://"+host+"/"+dataBase;
           }else
             DBMYSQL ="jdbc:mysql://"+host+":"+port+"/"+dataBase;
           
        log.AddMessage("DBMYSQL "+DBMYSQL,false);   
    try {
            try{
		Statement stm1 = (Statement)connection.createStatement();			
		stm1.executeUpdate("DROP TABLE "+TablesName.nameDsa());
		stm1.close();
		}catch(SQLException e){
	         }
            try{
		Statement stm2 = (Statement)connection.createStatement();
		stm2.executeUpdate("DROP TABLE "+TablesName.nameDsb());
		stm2.close();
		}catch(SQLException e){
                }
        
          Class.forName("com.mysql.jdbc.Driver");
          conn = DriverManager.getConnection(DBMYSQL,userName,passWord);
     	       
        String query = "select column_name from information_schema.columns where table_name = '"+tableDSA+"' and table_schema = '"+dataBase+"'order by ordinal_position";
        java.sql.Statement stm = (java.sql.Statement)conn.createStatement();
        java.sql.ResultSet rs = stm.executeQuery(query);
        
        column = new ArrayList<String>();       
        
        while(rs.next()){
            column.add(rs.getString("column_name"));
        }
        
        rs.close();
        stm.close();
        
        int dimDSA = column.size();
        if (dimDSA==0) throw new Exception("Table "+tableDSA+" not found in MySQL DB "+dataBase);
        String attributeDSA = "";
        createDSA = "CREATE TABLE "+TablesName.nameDsa()+" (KEY_DSA INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, \n";
	for(int i=0; i < dimDSA; i++){
            if (column.get(i).toString().equals("")) throw new Exception("Column name missing in Dataset A");
		createDSA = createDSA+ column.get(i).toString().toUpperCase()+" VARCHAR(250), \n";
	    if(i< dimDSA-1)
		attributeDSA = attributeDSA + column.get(i).toString()+", \n";
	   else
		attributeDSA = attributeDSA + column.get(i).toString()+" \n";
	}
	createDSA = createDSA+" PRIMARY KEY (KEY_DSA));";
	java.sql.Statement stmDSA = (Statement)connection.createStatement();
	stmDSA.executeUpdate(createDSA);
	stmDSA.close();
			
        String insStr; 
        
        java.sql.Statement stmSelectDSAMySql = (Statement)conn.createStatement();
        java.sql.ResultSet rsSelect = stmSelectDSAMySql.executeQuery("select * from " + tableDSA);
               
        int jj=1;        
        while(rsSelect.next()){
            insStr = "insert into "+TablesName.nameDsa()+" values ("+jj+", ";
            
            for(int j= 1; j<= dimDSA; j++){
            if(j< dimDSA){
                  if(rsSelect.getString(j)== null){
                      insStr += "' ', ";    
                  }else{ 
                    insStr += "'"+rsSelect.getString(j).replaceAll("'", "''")+"', ";
                  }
               }else{
                    if(rsSelect.getString(j)==null){
                      insStr += "' ')";  
                    }else{
                      insStr += "'"+rsSelect.getString(j).replaceAll("'", "''")+"')";
                    }
               }
        }
       
        java.sql.Statement stmLoadDSA = (Statement)connection.createStatement();
        stmLoadDSA.executeUpdate(insStr);
	stmLoadDSA.close();
        jj++;
        }
        
        stm.close();
        log.AddMessage("Table "+tableDSA+" Loaded",false);                     
       
       query = "select column_name from information_schema.columns where table_name = '"+tableDSB+"' and table_schema = '"+dataBase+"'order by ordinal_position";
       stm = (java.sql.Statement)conn.createStatement();
       rs = stm.executeQuery(query);
        
       column1 = new ArrayList<String>();       
        
        while(rs.next()){
            column1.add(rs.getString("column_name"));
        }
        
        rs.close();
        stm.close();
        
        int dimDSB = column1.size();
        if (dimDSB==0) throw new Exception("Table "+tableDSB+" not found in MySQL DB "+dataBase);
        String attributeDSB = "";
        createDSB = "CREATE TABLE "+TablesName.nameDsb()+" (KEY_DSB INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, \n";
	for(int i=0; i < dimDSB; i++){
            if (column1.get(i).toString().equals("")) throw new Exception("Column name missing in Dataset B");
		createDSB = createDSB+ column1.get(i).toString().toUpperCase()+" VARCHAR(250), \n";
	    if(i< dimDSB-1)
		attributeDSB = attributeDSB + column1.get(i).toString()+", \n";
	   else
		attributeDSB = attributeDSB + column1.get(i).toString()+" \n";
	}
	createDSB = createDSB+" PRIMARY KEY (KEY_DSB));";
	java.sql.Statement stmDSB = (Statement)connection.createStatement();
	stmDSB.executeUpdate(createDSB);
	stmDSB.close();
			
        
        java.sql.Statement stmSelectDSBMySql = (Statement)conn.createStatement();
        java.sql.ResultSet rsSelectB = stmSelectDSBMySql.executeQuery("select * from " + tableDSB);
               
        jj=1;        
        while(rsSelectB.next()){
            insStr = "insert into "+TablesName.nameDsb()+" values ("+jj+", ";
            
            for(int j= 1; j<= dimDSB; j++){
            if(j< dimDSB){
                  if(rsSelectB.getString(j)== null){
                      insStr += "' ', ";    
                  }else{ 
                    insStr += "'"+rsSelectB.getString(j).replaceAll("'", "''")+"', ";
                  }
               }else{
                    if(rsSelectB.getString(j)==null){
                      insStr += "' ')";  
                    }else{
                      insStr += "'"+rsSelectB.getString(j).replaceAll("'", "''")+"')";
                    }
               }
        }
       
        java.sql.Statement stmLoadDSB = (Statement)connection.createStatement();
        stmLoadDSB.executeUpdate(insStr);
	stmLoadDSB.close();
        jj++;
        }
        
        stm.close();
        log.AddMessage("Table "+tableDSB+" Loaded",false);         
        
        Statement stmdr = (Statement)connection.createStatement();
        stmdr.executeUpdate("DROP TABLE IF EXISTS "+TablesName.nameReconciledSchema());
        stmdr.close();

        String createReconciledSchema = "CREATE TABLE "+TablesName.nameReconciledSchema()+" (COMMON_ATTRIBUTES VARCHAR(250));";

        Statement stmcr = (Statement)connection.createStatement();
        stmcr.executeUpdate(createReconciledSchema);
        stmcr.close();
        
        query = "select a.column_name from information_schema.columns a, information_schema.columns b ";
        query = query + " where a.table_name = '"+tableDSA+"' and a.table_schema = '"+dataBase+"' ";
        query = query + " and b.table_name = '"+tableDSB+"' and b.table_schema = '"+dataBase+"' ";
        query = query + " and a.column_name=b.column_name ";
        query = query + " order by a.ordinal_position";
        Statement stmca = (java.sql.Statement)conn.createStatement();
        rs = stmca.executeQuery(query);
        Statement stm2 = (java.sql.Statement)connection.createStatement();
        String insertString1="";
        
        while(rs.next()){
            insertString1 = "INSERT INTO " +TablesName.nameReconciledSchema()+ " VALUES ('"+rs.getString("column_name").toUpperCase()+"');";
            stm2.executeUpdate(insertString1);
            if (rs.getRow()>100) throw new Exception("Number of common attributes exceeds maximum of 100 elements");
        }
        stmca.close();
        stm2.close();
        
        conn.close(); 
   
 }catch(Exception e){
           log.AddMessage("ERROR: "+e.getMessage());
           throw new RuntimeException("Problems to read dataset from MySQL DB:"+ e.getMessage());
       } 
}
}
