package it.istat.relais.gui;

import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

public class BagBuilder {
	
	private Container container;
	private GridBagLayout layout = new GridBagLayout();
	private GridBagConstraints constraints = new GridBagConstraints();
	
	public BagBuilder(Container container) {
		this.container = container;
		this.container.setLayout(layout);
	}
	
	public GridBagConstraints constraints() {
		return constraints;
	}
	
	public void add(Component component, int gridx, int gridy, int gridwidth, int gridheight,
					int weightx, int weighty, int fill, int anchor) {
		constraints.gridx = gridx;
		constraints.gridy = gridy;
		constraints.gridwidth = gridwidth;
		constraints.gridheight = gridheight;
		constraints.weightx = weightx;
		constraints.weighty = weighty;
		constraints.fill = fill;
		constraints.anchor = anchor;
		
		container.add(component, constraints);
	}
	
}
