
package it.istat.relais.gui;

import it.istat.relais.constants.TablesName;
import it.istat.relais.matchingVariables.MatchingVariables;
import it.istat.relais.metrics.dataStructure.MetricMatchingVariableVector;
import it.istat.relais.project.DBConfiguration;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.Toolkit;
import javax.swing.JLabel;
import javax.swing.JPanel;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;






public class DetailsDialog extends javax.swing.JDialog {
    private JPanel panel;
    private Connection conn; 
    /** Creates new form DetailsDialog */
    public DetailsDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setTitle("Matching Variables Details");
        Image img = java.awt.Toolkit.getDefaultToolkit().createImage("Img\\erre4.jpg");
        this.setIconImage(img);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
        setLocation((screenSize.width - frameSize.width) / 2,
					(screenSize.height - frameSize.height) / 2);
        this.setVisible(false);
   
        
        
    }


   public void showFS(MatchingVariables mv) {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
   Dimension frameSize = getSize();
   String str ="";
   
       MetricMatchingVariableVector mmvv2 =  new MetricMatchingVariableVector();
        mmvv2 = mv.getMetricMatchingVariableVector();
        setLayout(new BorderLayout());  
        panel=new JPanel();  
        panel.setLayout(new FlowLayout());  
        add(panel);  
      
       str +="<html><table border=\"2\">";
       str+="<tr><td>VARIABLE NAME </td><td>COMPARISON FUNCTION</td><td>THRESHOLD</td><td>WINDOW</td></tr>";
       for(int i=0; i<mmvv2.size();i++){
         str+="<tr><td>"+mmvv2.get(i).getMatchingVariable()+"</td><td>"+mmvv2.get(i).getComparisonFunction()+"</td>";
         str+="<td>"+mmvv2.get(i).getMetricThreshold()+"</td><td>"+mmvv2.get(i).getWindowSize()+"</td></tr>";
        }
       str+="</table></html>";
        JLabel label=new JLabel(str);  
       add(label, BorderLayout.PAGE_START);       
       setSize((screenSize.width - frameSize.width) / 2,(screenSize.height - frameSize.height) / 2);  
       setVisible(true);  
     
      
    }
    
   public void showRB(){
     Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
     Dimension frameSize = getSize();
     conn = DBConfiguration.getConnection();
     String str ="";
     setLayout(new BorderLayout());  
     panel=new JPanel();  
     panel.setLayout(new FlowLayout());  
     add(panel);  
     str +="<html><br>";
     try{
     Statement stm =(Statement)conn.createStatement();
     ResultSet rs = stm.executeQuery("SELECT RULE FROM "+TablesName.nameSetting()+";");
     rs.next();
     str += rs.getString(1);
     rs.close();
     stm.close();
     }catch(Exception e){
         System.out.println(e);
     }
     str += "</html>";     
     
     JLabel label=new JLabel(str);  
     add(label, BorderLayout.PAGE_START);       
     setSize((screenSize.width - frameSize.width) / 2,(screenSize.height - frameSize.height) / 2);  
     setVisible(true);  
       
   }
   
  public void showEQ(){
     Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
     Dimension frameSize = getSize();
     setLayout(new BorderLayout());  
     String str ="";
     
     panel=new JPanel();  
     panel.setLayout(new FlowLayout());  
     add(panel);  
     conn = DBConfiguration.getConnection();
     
     str +="<html><table border=\"2\">";
       str+="<tr><td>VARIABLE NAME </td><td>COMPARISON FUNCTION</td><td>THRESHOLD</td><td>WINDOW</td></tr>";
     try{
         Statement stm =(Statement)conn.createStatement();
         ResultSet rs = stm.executeQuery("SELECT * FROM "+TablesName.nameMatchingVeriables()+";");
         while(rs.next()){
         str+="<tr><td>"+rs.getString(1)+"</td><td>"+rs.getString(2) +"</td>";
         str+="<td>"+rs.getDouble(3) +"</td><td>"+rs.getInt(4) +"</td></tr>";
        }
     rs.close();
     stm.close();
     }catch(Exception e){
         System.out.println(e);
     }
     str+="</table></html>";
     JLabel label=new JLabel(str);  
     add(label, BorderLayout.PAGE_START);       
     setSize((screenSize.width - frameSize.width) / 2,(screenSize.height - frameSize.height) / 2);  
     setVisible(true);  
       
   }
   
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        OKButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        OKButton1.setText("OK");
        OKButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OKButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(257, Short.MAX_VALUE)
                .addComponent(OKButton1)
                .addGap(96, 96, 96))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(254, Short.MAX_VALUE)
                .addComponent(OKButton1)
                .addGap(23, 23, 23))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void OKButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OKButton1ActionPerformed
dispose();
}//GEN-LAST:event_OKButton1ActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                DetailsDialog dialog = new DetailsDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0); 
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton OKButton1;
    // End of variables declaration//GEN-END:variables

}
