package it.istat.relais.gui.task;

public abstract class AbstractTask {
	
	private Command successCommand;
	private Command failCommand;
	
	public Command getSuccessCommand() {
		return successCommand;
	}
	
	public Command getFailCommand() {
		return failCommand;
	}
	
	public void setSuccessCommand(Command successCommand) {
		this.successCommand = successCommand;
	}
	
	public void setFailCommand(Command failCommand) {
		this.failCommand = failCommand;
	}
	
	public void succeed() {
		getSuccessCommand().execute();
	}
	
	public void fail() {
		getFailCommand().execute();
	}
	
	public abstract void run();
	
}
