
package it.istat.relais.gui.task;

import it.istat.relais.constants.TablesName;
import it.istat.relais.gui.DrawFrame;
import it.istat.relais.project.CurrentStatus;
import it.istat.relais.project.Summary;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;

public class DrawFunctionTask extends AbstractTask {

    private Connection conn;
    private VariablesSetting vs;
    private Summary sum;
    private DrawFrame dd;
    private int status = 0;
    private CurrentStatus cs;
    private String tableMU;
    
    public DrawFunctionTask (Connection conn, VariablesSetting vs, Summary sumIn, CurrentStatus cs){
    this.conn = conn;
    this.vs = vs;
    this.sum = sumIn;
    this.cs = cs;
    this.tableMU = TablesName.nameMU();
    }
    
    public DrawFunctionTask (Connection conn, VariablesSetting vs, Summary sumIn, CurrentStatus cs, String TableMU){
    this.conn = conn;
    this.vs = vs;
    this.sum = sumIn;
    this.cs = cs;
    this.tableMU = TableMU;
    }
    
    @Override
    public void run() {
        dd = new DrawFrame(conn, vs, sum, cs,tableMU);
        succeed();
        status = 1;
    }
    
    public int getDrawFrameStatus(){
       
        return status;
    }
}
