
package it.istat.relais.gui.task;

import it.istat.relais.datasetInput.ReadingDBOracle;
import java.sql.Connection;


public class LoadFromDBOracleTask  extends AbstractTask{
    private String dataBase;
    private String host;
    private String port;
    private String user;
    private String password;
    private String tableDSA;
    private String tableDSB;
    private Connection conn;
    
    public LoadFromDBOracleTask(Connection conn,String dataBase, String host, String port, String user, String password, String tableDSA, String tableDSB) {
        this.dataBase =dataBase;
        this.host = host;
        this.port = port;
        this.user =user;
        this.password = password;
        this.tableDSA = tableDSA;
        this.tableDSB = tableDSB;
        this.conn =conn;
    }
    public void run() {
        try {
            ReadingDBOracle ridbo; 
            ridbo = new ReadingDBOracle(conn);
            ridbo.ReadingDB(host, port, dataBase, user, password, tableDSA, tableDSB);
            succeed();
        } catch (Exception ex) {
                fail();
            }
            
        }
}
   
