package it.istat.relais.metrics.dataStructure;

public class MetricMatchingVariable {
	private String matchingVariable;
	private String comparisonFunction;
	private double metricThreshold;
        private int windowSize;
	
	public MetricMatchingVariable(){
		this.metricThreshold = 1.0;
                this.windowSize=0;
	}
	
	public MetricMatchingVariable(String matchingVariable, String comparisonFunction, double metricThreshold, int windowSize){
		this.matchingVariable = matchingVariable;
		this.comparisonFunction = comparisonFunction;
		this.metricThreshold = metricThreshold;
                this.windowSize = windowSize;
	}

	public String getComparisonFunction() {
		return comparisonFunction;
	}

	public void setComparisonFunction(String comparisonFunction) {
		this.comparisonFunction = comparisonFunction;
	}

	public String getMatchingVariable() {
		return matchingVariable;
	}

	public void setMatchingVariable(String matchingVariable) {
		this.matchingVariable = matchingVariable;
	}

	public double getMetricThreshold() {
		return metricThreshold;
	}

	public void setMetricThreshold(double metricThreshold) {
		this.metricThreshold = metricThreshold;
	}
	
        public int getWindowSize(){
            return windowSize;
        }
        
        public void setWindowSize(int windowSize){
            this.windowSize = windowSize;
        }
}
