package it.istat.relais.metrics.dataStructure;

import java.util.Vector;

@SuppressWarnings("unchecked")
public class MetricMatchingVariableVector extends Vector {
	private static final long serialVersionUID = 1L;
	Vector<MetricMatchingVariable> vector;
	
	public MetricMatchingVariableVector(){
		vector = new Vector<MetricMatchingVariable>();
	}
 
	public void add(int index, MetricMatchingVariable mmv){
		vector.add(index,mmv);
	}
	
	public void addElement(MetricMatchingVariable mmv){
		vector.add(mmv);
	}
	
	public MetricMatchingVariable get(int index){
		
		MetricMatchingVariable mmv = vector.get(index);
		return mmv;
	}
        
        public int getIndex(MetricMatchingVariable mmvToFind){
		
		MetricMatchingVariable mmv;
                for (int index=0; index<vector.size(); index++) {
                    mmv=vector.get(index);
                    if (mmvToFind.getMatchingVariable().equals(mmv.getMatchingVariable()) &&
                        mmvToFind.getComparisonFunction().equals(mmv.getComparisonFunction()) &&
                        mmvToFind.getMetricThreshold() == mmv.getMetricThreshold() &&
                        mmvToFind.getWindowSize() == mmv.getWindowSize())
                            return index; 
                }
		return -1;
	}
        
	public int size(){
		return vector.size();
	}
	
	public void set(int index, MetricMatchingVariable mmv){
		vector.set(index, mmv);
	} 
	
	public boolean contains(MetricMatchingVariable mmv){
		return vector.contains(mmv);
	}
	
	public int indexOf(MetricMatchingVariable mmv){
		return vector.indexOf(mmv);
	}
	
	public boolean removeElement(MetricMatchingVariable mmv){
		 return vector.remove(mmv);
	}

	public void removeElementAt(int index){
		vector.removeElementAt(index);
	}
        
        public void clear(){
            vector.clear();
        }

	public Vector<MetricMatchingVariable> getMetricMatchingVariable(){
		return this.vector;
	}

}
