package it.istat.relais.qualityMetaData;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class Completeness {
private Connection conn;
private String DS;
private String varName;
private int dimDS;

public Completeness(Connection conn, String DS, int dimDS, String varName){
    this.conn = conn;
    this.DS = DS;
    this.dimDS = dimDS;
    this.varName = varName;
}

/* returns evaluation of completeness for the variable */
public double EvaluateCompleteness(){
int numVarNotNull = 0;
double completeness = -1;
    try{
        Statement stm1 = (Statement)conn.createStatement();
        ResultSet rs1 = stm1.executeQuery("SELECT COUNT(*) FROM "+DS+" WHERE "+varName+"<>'';");
        rs1.next();
        numVarNotNull = rs1.getInt(1);
        rs1.close();
        stm1.close();

    completeness = ((double)numVarNotNull/(double)dimDS);
    }catch(Exception e){
        e.printStackTrace();
    }
return completeness; 
}
}
